/**
 * ADT specification of a queue.
 *
 * Project <A HREF = "http://gloss.di.fc.ul.pt/congu/"> ConGu </A>.
 * @author Joao Abreu, Vasco T. Vasconcelos
 * @version $Id: Queue.spc 1766 2010-09-16 17:03:41Z pc $
 */
specification Queue[Element]

  sorts
    Queue[Element]

  constructors
    make: --> Queue[Element];
    enqueue: Queue[Element] Element --> Queue[Element];

  observers
    front: Queue[Element] -->? Element;
    dequeue:  Queue[Element] -->? Queue[Element];
    isEmpty: Queue[Element];

  domains
    Q: Queue[Element];

    front(Q) if not isEmpty(Q);
    dequeue(Q)  if not isEmpty(Q);

  axioms
    Q: Queue[Element];
    E: Element;

    front(enqueue(Q, E)) = E when isEmpty(Q) else front(Q);
    dequeue(enqueue(Q, E)) = Q when isEmpty(Q) else enqueue(dequeue(Q), E);
    isEmpty(make());
    not isEmpty(enqueue (Q, E));

end specification
