import java.util.Random;
 
/**
 * A class to test a Queue
 * 
 * @author Luis Reis
 * @version $Id: QueueRandomTest.java 1767 2013-06-11 16:10:02 asantos $
 */
public class QueueRandomTest {

	/**
	 * Used to randomize the operations and values
	 */
    private Random rand;

    /**
     * The queue under testing
     */
    private ArrayQueue<Integer> queue;

    /**
     * The number of operations to be performed
     */
    private int howMany;

    /**
     * Constructor for QueueRandomTest
     * 
     * @param queue - the queue to be tested
     * @param howMany - how many operations should be performed
     */
    public QueueRandomTest(ArrayQueue<Integer> queue, int howMany) {
        this.queue = queue;
        this.rand = new Random();
        this.howMany = howMany;
    }

    /**
     * Performs the chosen number of random operations
     */
    public void run() {
        for (int i = 0; i < howMany; i++) {
            switch (rand.nextInt(4)) {
                case 0:
                    System.out.println("enqueue ");
                    queue.offer(new Integer(rand.nextInt(Integer.MAX_VALUE)));
                    break;
                case 1:
                    if (!queue.isEmpty()) {
                        System.out.println("front ");
                        queue.element();
                    }
                    break;
                case 2:
                    if (!queue.isEmpty()) {
                        System.out.println("dequeue ");
                        queue.remove();
                    }
                    break;
                case 3:
                    System.out.println("isEmpty ");
                    queue.isEmpty();
                    break;
            }
        }
        System.out.println("\n Finished");
    }
}
